<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>magpar: util/ipol.c Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body>
<!-- Generated by Doxygen 1.6.3 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Data&nbsp;Structures</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="files.html"><span>File&nbsp;List</span></a></li>
      <li><a href="globals.html"><span>Globals</span></a></li>
    </ul>
  </div>
  <div class="navpath"><a class="el" href="dir_81f17f03227d7067ce13f3651b0bf66b.html">util</a>
  </div>
</div>
<div class="contents">
<h1>ipol.c</h1><a href="ipol_8c.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">    This file is part of magpar.</span>
<a name="l00003"></a>00003 <span class="comment"></span>
<a name="l00004"></a>00004 <span class="comment">    Copyright (C) 2002-2010 Werner Scholz</span>
<a name="l00005"></a>00005 <span class="comment"></span>
<a name="l00006"></a>00006 <span class="comment">    www:   http://www.magpar.net/</span>
<a name="l00007"></a>00007 <span class="comment">    email: magpar(at)magpar.net</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">    magpar is free software; you can redistribute it and/or modify</span>
<a name="l00010"></a>00010 <span class="comment">    it under the terms of the GNU General Public License as published by</span>
<a name="l00011"></a>00011 <span class="comment">    the Free Software Foundation; either version 2 of the License, or</span>
<a name="l00012"></a>00012 <span class="comment">    (at your option) any later version.</span>
<a name="l00013"></a>00013 <span class="comment"></span>
<a name="l00014"></a>00014 <span class="comment">    magpar is distributed in the hope that it will be useful,</span>
<a name="l00015"></a>00015 <span class="comment">    but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00016"></a>00016 <span class="comment">    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the</span>
<a name="l00017"></a>00017 <span class="comment">    GNU General Public License for more details.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">    You should have received a copy of the GNU General Public License</span>
<a name="l00020"></a>00020 <span class="comment">    along with magpar; if not, write to the Free Software</span>
<a name="l00021"></a>00021 <span class="comment">    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00022"></a>00022 <span class="comment">*/</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="keyword">static</span> <span class="keywordtype">char</span> <span class="keyword">const</span> Id[] = <span class="stringliteral">&quot;$Id: ipol.c 2962 2010-02-04 19:50:44Z scholz $\n\n&quot;</span>;
<a name="l00025"></a>00025 <span class="keyword">static</span> <span class="keywordtype">char</span> <span class="keyword">const</span> Td[] = <span class="stringliteral">&quot;$Today: &quot;</span> __FILE__ <span class="stringliteral">&quot;  &quot;</span> __DATE__ <span class="stringliteral">&quot;  &quot;</span>  __TIME__  <span class="stringliteral">&quot; $\n\n&quot;</span>;
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="util_8h.html">util.h</a>&quot;</span>
<a name="l00028"></a>00028 
<a name="l00029"></a><a class="code" href="ipol_8c.html#a624dbcb8b6ccc24c9bf891c174f60b6d">00029</a> <span class="preprocessor">#define MAXLINELEN 100000</span>
<a name="l00030"></a><a class="code" href="ipol_8c.html#a6ee2a24c96c226b833b53dd49d8a25d7">00030</a> <span class="preprocessor"></span><span class="preprocessor">#define HTCOL 3</span>
<a name="l00031"></a>00031 <span class="preprocessor"></span>
<a name="l00032"></a>00032 <span class="comment">/*</span>
<a name="l00033"></a>00033 <span class="comment">input file structure:</span>
<a name="l00034"></a>00034 <span class="comment">-----------</span>
<a name="l00035"></a>00035 <span class="comment">n</span>
<a name="l00036"></a>00036 <span class="comment">x_0  y_0</span>
<a name="l00037"></a>00037 <span class="comment">x_1  y_1</span>
<a name="l00038"></a>00038 <span class="comment">x_2  y_2</span>
<a name="l00039"></a>00039 <span class="comment">x_3  y_3</span>
<a name="l00040"></a>00040 <span class="comment">...</span>
<a name="l00041"></a>00041 <span class="comment">x_n  y_n</span>
<a name="l00042"></a>00042 <span class="comment">-----------</span>
<a name="l00043"></a>00043 <span class="comment"></span>
<a name="l00044"></a>00044 <span class="comment">xydata structure:</span>
<a name="l00045"></a>00045 <span class="comment">-----------------------------</span>
<a name="l00046"></a>00046 <span class="comment">x_0  y_0  (y_1-y_0)/(x_1-x_0)</span>
<a name="l00047"></a>00047 <span class="comment">x_1  y_1  (y_2-y_1)/(x_2-x_1)</span>
<a name="l00048"></a>00048 <span class="comment">x_2  y_2  (y_3-y_2)/(x_3-x_2)</span>
<a name="l00049"></a>00049 <span class="comment">x_3  y_3  (y_4-y_3)/(x_4-x_3)</span>
<a name="l00050"></a>00050 <span class="comment">...</span>
<a name="l00051"></a>00051 <span class="comment">x_n  y_n  0</span>
<a name="l00052"></a>00052 <span class="comment">-----------------------------</span>
<a name="l00053"></a>00053 <span class="comment">*/</span>
<a name="l00054"></a>00054 
<a name="l00055"></a><a class="code" href="util_8h.html#a7c6add33a29c7ae759615a08798ee75d">00055</a> <span class="keywordtype">int</span> <a class="code" href="ipol_8c.html#a7c6add33a29c7ae759615a08798ee75d">readht</a>(FILE *fd,PetscReal **indata,<span class="keyword">const</span> <span class="keywordtype">int</span> col)
<a name="l00056"></a>00056 {
<a name="l00057"></a>00057   <span class="keywordtype">int</span>            nrows;
<a name="l00058"></a>00058   PetscReal      *xydata;
<a name="l00059"></a>00059 
<a name="l00060"></a>00060   <a class="code" href="griddata_8h.html#a3d9da926137619fd02adb245a08536c7">MagparFunctionLogBegin</a>;
<a name="l00061"></a>00061 
<a name="l00062"></a>00062   <span class="keywordtype">int</span> rank,size;
<a name="l00063"></a>00063   ierr = MPI_Comm_size(PETSC_COMM_WORLD,&amp;size);CHKERRQ(ierr);
<a name="l00064"></a>00064   ierr = MPI_Comm_rank(PETSC_COMM_WORLD,&amp;rank);CHKERRQ(ierr);
<a name="l00065"></a>00065 
<a name="l00066"></a>00066   <span class="keywordflow">if</span> (col&lt;2) {
<a name="l00067"></a>00067     SETERRQ1(PETSC_ERR_ARG_CORRUPT,<span class="stringliteral">&quot;col=%i &lt; 2!\n&quot;</span>,col);
<a name="l00068"></a>00068   }
<a name="l00069"></a>00069 
<a name="l00070"></a>00070   <span class="comment">/* only the first processor reads the file */</span>
<a name="l00071"></a>00071   <span class="keywordflow">if</span> (!rank) {
<a name="l00072"></a>00072     <span class="comment">/* get number of lines */</span>
<a name="l00073"></a>00073     fscanf(fd,<span class="stringliteral">&quot;%i\n&quot;</span>,&amp;nrows);
<a name="l00074"></a>00074     PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;Reading column %i, %i lines\n&quot;</span>,col,nrows);
<a name="l00075"></a>00075 
<a name="l00076"></a>00076     <span class="comment">/* account for additional first and last entry */</span>
<a name="l00077"></a>00077     nrows += 2;
<a name="l00078"></a>00078 
<a name="l00079"></a>00079     ierr = PetscMalloc(<a class="code" href="ipol_8c.html#a6ee2a24c96c226b833b53dd49d8a25d7">HTCOL</a>*nrows*<span class="keyword">sizeof</span>(PetscReal),&amp;xydata);CHKERRQ(ierr);
<a name="l00080"></a>00080 
<a name="l00081"></a>00081     <span class="comment">/* get xydata from file (leave room for first ) */</span>
<a name="l00082"></a>00082     <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=1; i&lt;nrows-1; i++) {
<a name="l00083"></a>00083       <span class="keywordtype">int</span> k;
<a name="l00084"></a>00084       <span class="comment">/* read x from first column */</span>
<a name="l00085"></a>00085 <span class="preprocessor">#ifdef PETSC_USE_SINGLE</span>
<a name="l00086"></a>00086 <span class="preprocessor"></span>      k=fscanf(fd,<span class="stringliteral">&quot;%f&quot;</span>,xydata+i*<a class="code" href="ipol_8c.html#a6ee2a24c96c226b833b53dd49d8a25d7">HTCOL</a>+0);
<a name="l00087"></a>00087 <span class="preprocessor">#else</span>
<a name="l00088"></a>00088 <span class="preprocessor"></span>      k=fscanf(fd,<span class="stringliteral">&quot;%lf&quot;</span>,xydata+i*<a class="code" href="ipol_8c.html#a6ee2a24c96c226b833b53dd49d8a25d7">HTCOL</a>+0);
<a name="l00089"></a>00089 <span class="preprocessor">#endif</span>
<a name="l00090"></a>00090 <span class="preprocessor"></span>      <span class="keywordflow">if</span> (k!=1) {
<a name="l00091"></a>00091         SETERRQ2(PETSC_ERR_FILE_UNEXPECTED,
<a name="l00092"></a>00092           <span class="stringliteral">&quot;xydata corrupt in row %i col %i\n&quot;</span>,
<a name="l00093"></a>00093           i,1
<a name="l00094"></a>00094         );
<a name="l00095"></a>00095       }
<a name="l00096"></a>00096 
<a name="l00097"></a>00097       <span class="comment">/* read y from column col */</span>
<a name="l00098"></a>00098       <span class="keywordflow">for</span> (<span class="keywordtype">int</span> j=1; j&lt;col; j++) {
<a name="l00099"></a>00099 <span class="preprocessor">#ifdef PETSC_USE_SINGLE</span>
<a name="l00100"></a>00100 <span class="preprocessor"></span>        k=fscanf(fd,<span class="stringliteral">&quot;%f&quot;</span>,xydata+i*<a class="code" href="ipol_8c.html#a6ee2a24c96c226b833b53dd49d8a25d7">HTCOL</a>+1);
<a name="l00101"></a>00101 <span class="preprocessor">#else</span>
<a name="l00102"></a>00102 <span class="preprocessor"></span>        k=fscanf(fd,<span class="stringliteral">&quot;%lf&quot;</span>,xydata+i*<a class="code" href="ipol_8c.html#a6ee2a24c96c226b833b53dd49d8a25d7">HTCOL</a>+1);
<a name="l00103"></a>00103 <span class="preprocessor">#endif</span>
<a name="l00104"></a>00104 <span class="preprocessor"></span>
<a name="l00105"></a>00105         <span class="keywordflow">if</span> (k!=1) {
<a name="l00106"></a>00106           SETERRQ2(PETSC_ERR_FILE_UNEXPECTED,
<a name="l00107"></a>00107             <span class="stringliteral">&quot;xydata in corrupt in row %i col %i\n&quot;</span>,
<a name="l00108"></a>00108             i,j
<a name="l00109"></a>00109           );
<a name="l00110"></a>00110         }
<a name="l00111"></a>00111       }
<a name="l00112"></a>00112       <span class="comment">/* read remainder of this line */</span>
<a name="l00113"></a>00113       <span class="keywordtype">char</span> msg[<a class="code" href="ipol_8c.html#a624dbcb8b6ccc24c9bf891c174f60b6d">MAXLINELEN</a>];
<a name="l00114"></a>00114       fgets(msg,<a class="code" href="ipol_8c.html#a624dbcb8b6ccc24c9bf891c174f60b6d">MAXLINELEN</a>,fd);
<a name="l00115"></a>00115     }
<a name="l00116"></a>00116 
<a name="l00117"></a>00117     <span class="comment">/* set first xydata set */</span>
<a name="l00118"></a>00118     xydata[0]=PETSC_MIN;
<a name="l00119"></a>00119     xydata[1]=0.0;
<a name="l00120"></a>00120     xydata[2]=0.0;
<a name="l00121"></a>00121 
<a name="l00122"></a>00122     <span class="comment">/* set last xydata set */</span>
<a name="l00123"></a>00123     xydata[<a class="code" href="ipol_8c.html#a6ee2a24c96c226b833b53dd49d8a25d7">HTCOL</a>*(nrows-1)+0]=PETSC_MAX;
<a name="l00124"></a>00124     xydata[<a class="code" href="ipol_8c.html#a6ee2a24c96c226b833b53dd49d8a25d7">HTCOL</a>*(nrows-1)+1]=0.0;
<a name="l00125"></a>00125     xydata[<a class="code" href="ipol_8c.html#a6ee2a24c96c226b833b53dd49d8a25d7">HTCOL</a>*(nrows-1)+2]=0.0;
<a name="l00126"></a>00126 
<a name="l00127"></a>00127     <span class="comment">/* calculate dH1/dt and dH2/dt */</span>
<a name="l00128"></a>00128     <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0; i&lt;nrows-1; i++) {
<a name="l00129"></a>00129       xydata[i*<a class="code" href="ipol_8c.html#a6ee2a24c96c226b833b53dd49d8a25d7">HTCOL</a>+2] = (xydata[(i+1)*<a class="code" href="ipol_8c.html#a6ee2a24c96c226b833b53dd49d8a25d7">HTCOL</a>+1]-xydata[i*<a class="code" href="ipol_8c.html#a6ee2a24c96c226b833b53dd49d8a25d7">HTCOL</a>+1])/
<a name="l00130"></a>00130                           (xydata[(i+1)*<a class="code" href="ipol_8c.html#a6ee2a24c96c226b833b53dd49d8a25d7">HTCOL</a>+0]-xydata[i*<a class="code" href="ipol_8c.html#a6ee2a24c96c226b833b53dd49d8a25d7">HTCOL</a>+0]);
<a name="l00131"></a>00131     }
<a name="l00132"></a>00132 
<a name="l00133"></a>00133     PetscPrintf(PETSC_COMM_WORLD,
<a name="l00134"></a>00134       <span class="stringliteral">&quot;%14s %14s %14s\n&quot;</span>,
<a name="l00135"></a>00135       <span class="stringliteral">&quot;time&quot;</span>,<span class="stringliteral">&quot;ts1&quot;</span>,<span class="stringliteral">&quot;dts1/dt&quot;</span>
<a name="l00136"></a>00136     );
<a name="l00137"></a>00137 
<a name="l00138"></a>00138     <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0; i&lt;nrows; i++) {
<a name="l00139"></a>00139       PetscPrintf(PETSC_COMM_WORLD,
<a name="l00140"></a>00140         <span class="stringliteral">&quot;%14e %14e %14e\n&quot;</span>,
<a name="l00141"></a>00141         xydata[<a class="code" href="ipol_8c.html#a6ee2a24c96c226b833b53dd49d8a25d7">HTCOL</a>*i+0],
<a name="l00142"></a>00142         xydata[<a class="code" href="ipol_8c.html#a6ee2a24c96c226b833b53dd49d8a25d7">HTCOL</a>*i+1],
<a name="l00143"></a>00143         xydata[<a class="code" href="ipol_8c.html#a6ee2a24c96c226b833b53dd49d8a25d7">HTCOL</a>*i+2]
<a name="l00144"></a>00144       );
<a name="l00145"></a>00145     }
<a name="l00146"></a>00146   }
<a name="l00147"></a>00147 
<a name="l00148"></a>00148   <span class="comment">/* broadcast xydata to all processors */</span>
<a name="l00149"></a>00149   ierr = MPI_Bcast(&amp;nrows,1,MPI_INT,0,PETSC_COMM_WORLD);CHKERRQ(ierr);
<a name="l00150"></a>00150   <span class="keywordflow">if</span> (rank) {
<a name="l00151"></a>00151     ierr = PetscMalloc(<a class="code" href="ipol_8c.html#a6ee2a24c96c226b833b53dd49d8a25d7">HTCOL</a>*nrows*<span class="keyword">sizeof</span>(PetscReal),&amp;xydata);CHKERRQ(ierr);
<a name="l00152"></a>00152   }
<a name="l00153"></a>00153   ierr = MPI_Bcast(xydata,nrows*<a class="code" href="ipol_8c.html#a6ee2a24c96c226b833b53dd49d8a25d7">HTCOL</a>,MPIU_SCALAR,0,PETSC_COMM_WORLD);CHKERRQ(ierr);
<a name="l00154"></a>00154   *indata=xydata;
<a name="l00155"></a>00155 
<a name="l00156"></a>00156   <a class="code" href="griddata_8h.html#a8491466d8534a33d7163f5ea747e8210">MagparFunctionLogReturn</a>(0);
<a name="l00157"></a>00157 }
<a name="l00158"></a>00158 
<a name="l00159"></a><a class="code" href="util_8h.html#abffb8438135693435f870885676179f5">00159</a> PetscReal <a class="code" href="ipol_8c.html#a3e2699b016b84132ec08d3795b951dd9">getscalf</a>(PetscReal xydata[],PetscReal xval)
<a name="l00160"></a>00160 {
<a name="l00161"></a>00161   <span class="keywordtype">int</span>       tint;
<a name="l00162"></a>00162   PetscReal result;
<a name="l00163"></a>00163 
<a name="l00164"></a>00164   tint=0;
<a name="l00165"></a>00165   <span class="keywordflow">while</span> (xval &gt; xydata[<a class="code" href="ipol_8c.html#a6ee2a24c96c226b833b53dd49d8a25d7">HTCOL</a>*(tint+1)]) tint++;
<a name="l00166"></a>00166 
<a name="l00167"></a>00167   <span class="comment">/* calculate scaling factor */</span>
<a name="l00168"></a>00168   result=(xval-xydata[<a class="code" href="ipol_8c.html#a6ee2a24c96c226b833b53dd49d8a25d7">HTCOL</a>*tint+0])*xydata[<a class="code" href="ipol_8c.html#a6ee2a24c96c226b833b53dd49d8a25d7">HTCOL</a>*tint+2]+xydata[<a class="code" href="ipol_8c.html#a6ee2a24c96c226b833b53dd49d8a25d7">HTCOL</a>*tint+1];
<a name="l00169"></a>00169 
<a name="l00170"></a>00170   <span class="keywordflow">return</span>(result);
<a name="l00171"></a>00171 }
<a name="l00172"></a>00172 
<a name="l00173"></a><a class="code" href="util_8h.html#a66bd89f21bd6d58d24a7b7d7da8b5841">00173</a> <span class="keywordtype">int</span> <a class="code" href="ipol_8c.html#a66bd89f21bd6d58d24a7b7d7da8b5841">readxy</a>(FILE *fd,<span class="keyword">const</span> <span class="keywordtype">int</span> colx,<span class="keyword">const</span> <span class="keywordtype">int</span> coly,<span class="keywordtype">int</span> *n_rows,PetscReal **indata)
<a name="l00174"></a>00174 {
<a name="l00175"></a>00175   <span class="keywordtype">int</span>            nrows;
<a name="l00176"></a>00176   PetscReal      *xydata;
<a name="l00177"></a>00177 
<a name="l00178"></a>00178   <a class="code" href="griddata_8h.html#a3d9da926137619fd02adb245a08536c7">MagparFunctionLogBegin</a>;
<a name="l00179"></a>00179 
<a name="l00180"></a>00180   <span class="keywordtype">int</span> rank,size;
<a name="l00181"></a>00181   ierr = MPI_Comm_size(PETSC_COMM_WORLD,&amp;size);CHKERRQ(ierr);
<a name="l00182"></a>00182   ierr = MPI_Comm_rank(PETSC_COMM_WORLD,&amp;rank);CHKERRQ(ierr);
<a name="l00183"></a>00183 
<a name="l00184"></a>00184   <span class="keywordflow">if</span> (colx&lt;1) {
<a name="l00185"></a>00185     SETERRQ1(PETSC_ERR_ARG_CORRUPT,<span class="stringliteral">&quot;colx=%i &lt; 1!\n&quot;</span>,colx);
<a name="l00186"></a>00186   }
<a name="l00187"></a>00187   <span class="keywordflow">if</span> (coly&lt;1) {
<a name="l00188"></a>00188     SETERRQ1(PETSC_ERR_ARG_CORRUPT,<span class="stringliteral">&quot;coly=%i &lt; 1!\n&quot;</span>,coly);
<a name="l00189"></a>00189   }
<a name="l00190"></a>00190 
<a name="l00191"></a>00191   <span class="comment">/* only the first processor reads the file */</span>
<a name="l00192"></a>00192   <span class="keywordflow">if</span> (!rank) {
<a name="l00193"></a>00193     <span class="comment">/* get number of lines */</span>
<a name="l00194"></a>00194     fscanf(fd,<span class="stringliteral">&quot;%i\n&quot;</span>,&amp;nrows);
<a name="l00195"></a>00195     PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;Reading columns %i, %i, and %i lines\n&quot;</span>,colx,coly,nrows);
<a name="l00196"></a>00196 
<a name="l00197"></a>00197     ierr = PetscMalloc(2*nrows*<span class="keyword">sizeof</span>(PetscReal),&amp;xydata);CHKERRQ(ierr);
<a name="l00198"></a>00198 
<a name="l00199"></a>00199     <span class="comment">/* loop over all rows */</span>
<a name="l00200"></a>00200     <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0;i&lt;nrows;i++) {
<a name="l00201"></a>00201       PetscReal val,x,y;
<a name="l00202"></a>00202       x=y=val=PETSC_MIN;
<a name="l00203"></a>00203 
<a name="l00204"></a>00204       <span class="comment">/* loop over columns */</span>
<a name="l00205"></a>00205       <span class="keywordflow">for</span> (<span class="keywordtype">int</span> j=1;j&lt;=PetscMax(colx,coly);j++) {
<a name="l00206"></a>00206 
<a name="l00207"></a>00207         <span class="comment">/* read value */</span>
<a name="l00208"></a>00208         <span class="keywordtype">int</span> k;
<a name="l00209"></a>00209 <span class="preprocessor">#ifdef PETSC_USE_SINGLE</span>
<a name="l00210"></a>00210 <span class="preprocessor"></span>        k=fscanf(fd,<span class="stringliteral">&quot;%f&quot;</span>,&amp;val);
<a name="l00211"></a>00211 <span class="preprocessor">#else</span>
<a name="l00212"></a>00212 <span class="preprocessor"></span>        k=fscanf(fd,<span class="stringliteral">&quot;%lf&quot;</span>,&amp;val);
<a name="l00213"></a>00213 <span class="preprocessor">#endif</span>
<a name="l00214"></a>00214 <span class="preprocessor"></span>        <span class="keywordflow">if</span> (j==colx &amp;&amp; k==1) x=val;
<a name="l00215"></a>00215         <span class="keywordflow">if</span> (j==coly &amp;&amp; k==1) y=val;
<a name="l00216"></a>00216 
<a name="l00217"></a>00217         <span class="keywordflow">if</span> (x!=PETSC_MIN &amp;&amp; y!=PETSC_MIN) {
<a name="l00218"></a>00218           xydata[2*i+0]=x;
<a name="l00219"></a>00219           xydata[2*i+1]=y;
<a name="l00220"></a>00220           <span class="keywordflow">break</span>;
<a name="l00221"></a>00221         }
<a name="l00222"></a>00222       }
<a name="l00223"></a>00223 
<a name="l00224"></a>00224       <span class="comment">/* read remainder of this line */</span>
<a name="l00225"></a>00225       <span class="keywordtype">char</span> msg[<a class="code" href="ipol_8c.html#a624dbcb8b6ccc24c9bf891c174f60b6d">MAXLINELEN</a>];
<a name="l00226"></a>00226       fgets(msg,<a class="code" href="ipol_8c.html#a624dbcb8b6ccc24c9bf891c174f60b6d">MAXLINELEN</a>,fd);
<a name="l00227"></a>00227     }
<a name="l00228"></a>00228 
<a name="l00229"></a>00229 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00230"></a>00230 <span class="preprocessor"></span>    PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;%14s %14s\n&quot;</span>,<span class="stringliteral">&quot;x&quot;</span>,<span class="stringliteral">&quot;y&quot;</span>);
<a name="l00231"></a>00231 
<a name="l00232"></a>00232     <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0;i&lt;nrows;i++) {
<a name="l00233"></a>00233       PetscPrintf(PETSC_COMM_WORLD,
<a name="l00234"></a>00234         <span class="stringliteral">&quot;%14e %14e\n&quot;</span>,
<a name="l00235"></a>00235         xydata[2*i+0],
<a name="l00236"></a>00236         xydata[2*i+1]
<a name="l00237"></a>00237       );
<a name="l00238"></a>00238     }
<a name="l00239"></a>00239 <span class="preprocessor">#endif</span>
<a name="l00240"></a>00240 <span class="preprocessor"></span>  }
<a name="l00241"></a>00241 
<a name="l00242"></a>00242   <span class="comment">/* broadcast xydata to all processors */</span>
<a name="l00243"></a>00243   ierr = MPI_Bcast(&amp;nrows,1,MPI_INT,0,PETSC_COMM_WORLD);CHKERRQ(ierr);
<a name="l00244"></a>00244   <span class="keywordflow">if</span> (rank) {
<a name="l00245"></a>00245     ierr = PetscMalloc(2*nrows*<span class="keyword">sizeof</span>(PetscReal),&amp;xydata);CHKERRQ(ierr);
<a name="l00246"></a>00246   }
<a name="l00247"></a>00247   ierr = MPI_Bcast(xydata,nrows*2,MPIU_SCALAR,0,PETSC_COMM_WORLD);CHKERRQ(ierr);
<a name="l00248"></a>00248   *indata=xydata;
<a name="l00249"></a>00249 
<a name="l00250"></a>00250   *n_rows=nrows;
<a name="l00251"></a>00251 
<a name="l00252"></a>00252   <a class="code" href="griddata_8h.html#a8491466d8534a33d7163f5ea747e8210">MagparFunctionLogReturn</a>(0);
<a name="l00253"></a>00253 }
<a name="l00254"></a>00254 
</pre></div></div>
  <hr>
  <address>
    magpar - Parallel Finite Element Micromagnetics Package<br>
    Copyright (C) 2002-2010 Werner Scholz
  </address>
  </body>
</html>

